<template>
	<v-container>
		<v-row class="text-center">
			<v-col class="mb-4 mt-8">
				<h1 class="display-2 font-weight-bold mb-3">
					NarrativeWave Technical Assignment
				</h1>
				<button class="btn btn-primary" @click="fetchData()">
					Fetch parquet data
				</button>
			</v-col>

			<v-col
				class="mb-5"
				cols="12"
			>
				<v-card>
					<v-toolbar
						color="light_blue_section"
						flat
					>
						<v-icon class="mr-4">mdi-database</v-icon>
						<v-toolbar-title>Assets and Columns</v-toolbar-title>
						<v-progress-circular
							:size="24"
							color="teal lighten-1"
							class="float-right mr-0 ml-auto"
							indeterminate
							v-show="isLoading"
						></v-progress-circular>
					</v-toolbar>

					<v-row>
						<v-col cols="5">
							<v-card-text>
								<v-row >
									<v-col cols="4">
										<v-subheader>
											Assets
										</v-subheader>
									</v-col>
									<v-col cols="8">
										<v-select
											:value="filters.asset"
											@input="setActiveAsset"
											:items="computedAssets"
											menu-props="auto"
											label="Select"
											hide-details
											prepend-icon="mdi-buffer"
											single-line
										></v-select>
									</v-col>
									<v-col cols="4">
										<v-subheader>
											Columns
										</v-subheader>
									</v-col>
									<v-col cols="8">
										<v-select
											:value="filters.column"
											@input="setActiveColumn"
											:items="computedColumns"
											item-text="name"
											item-value="value"
											append-outer-icon="mdi-map"
											menu-props="auto"
											hide-details
											label="Select"
											single-line
										></v-select>
									</v-col>
									<v-col cols="4">
										<v-subheader>
											Start date
										</v-subheader>
									</v-col>
									<v-col
										cols="8"
									>
										<v-menu
											v-model="menu1"
											:close-on-content-click="false"
											:nudge-right="40"
											transition="scale-transition"
											offset-y
											min-width="auto"
										>
											<template v-slot:activator="{ on, attrs }">
												<v-text-field
													v-model="filters.start_date"
													label="After selected date..."
													prepend-icon="mdi-calendar"
													readonly
													v-bind="attrs"
													v-on="on"
												></v-text-field>
											</template>
											<v-date-picker
												v-model="filters.start_date"
												@input="menu1 = false"
											></v-date-picker>
										</v-menu>
									</v-col>
									<v-col cols="4">
										<v-subheader>
											End date
										</v-subheader>
									</v-col>
									<v-col
										cols="8"
									>
										<v-menu
											v-model="menu2"
											:close-on-content-click="false"
											:nudge-right="40"
											transition="scale-transition"
											offset-y
											min-width="auto"
										>
											<template v-slot:activator="{ on, attrs }">
												<v-text-field
													v-model="filters.end_date"
													label="Before selected date..."
													prepend-icon="mdi-calendar"
													readonly
													v-bind="attrs"
													v-on="on"
												></v-text-field>
											</template>
											<v-date-picker
												v-model="filters.end_date"
												@input="menu2 = false"
											></v-date-picker>
										</v-menu>
									</v-col>
								</v-row>
							</v-card-text>
						</v-col>

						<v-divider vertical></v-divider>

						<v-col
							cols="7"
						>
							<v-card class="mt-8 ml-2 elevation-0" flat>
								<div
									v-if="parquet.length === 0"
									key="title"
									class="text-h6 font-weight-light grey--text pa-4 text-center"
								>
									Assets records displayed here
								</div>

								<v-data-table
									:headers="table_headers"
									:items="parquet"
									:items-per-page="10"
									class="elevation-0"
								></v-data-table>

							</v-card>
						</v-col>
					</v-row>

					<v-divider></v-divider>

					<v-card-actions>
						<v-btn
							text
							depressed
							color="purple lighten-1"
							@click="reset"
						>
							Reset
						</v-btn>

						<v-spacer></v-spacer>

						<v-btn
							class="white--text"
							color="pink lighten-2"
							depressed
							text
							@click="fetchData"
						>
							Search
							<v-icon right>
								mdi-magnify
							</v-icon>
						</v-btn>
					</v-card-actions>
				</v-card>
			</v-col>

			<div class="d-flex align-center justify-center" style="width: 100%">
				<v-alert
					v-model="alert"
					dismissible
					color="warning"
					border="left"
					elevation="2"
					colored-border
					icon="mdi-alert"
				>
					{{ errorMessage }}
				</v-alert>
			</div>

			<div class="text-center ma-2">
				<v-snackbar
					v-model="snackbar"
				>
					{{ info }}

					<template v-slot:action="{ attrs }">
						<v-btn
							color="pink"
							text
							v-bind="attrs"
							@click="snackbar = false"
						>
							Close
						</v-btn>
					</template>
				</v-snackbar>
			</div>
		</v-row>
	</v-container>
</template>

<script>
	import axios from 'axios';

	export default {
		name: 'ParquetView',

		data() {
			return {
				table_headers: [
					{ text: 'Asset', value: 'asset' },
					{ text: 'Column', value: 'column' },
					{ text: 'Date', value: 'date_type' },
					{ text: 'Year', value: 'year' },
					{ text: 'Month', value: 'month' },
					{ text: 'Website', value: 'site'},
					{ text: 'TimeStamp', value: 'timestamp'},
					{ text: 'Value', value: 'value' }
				],
				assets_columns: [],
				parquet: [],
				assets: [],
				isLoading: false,
				filters: {
					asset: null,
					column: null,
					start_date: null,
					end_date: null
				},
				menu1: false,
				menu2: false,
				alert: false,
				errorMessage: '',
				snackbar: false,
				info: ''
			};
		},

		mounted() {
			this.fetchAssetsColumns();
		},

		computed: {
			shouldShowTree () {
				return this.assets.length > 0 && !this.isLoading;
			},
			computedAssets() {
				return this.assets_columns.map(entry => entry.name);
			},
			computedColumns() {
				if (_.isEmpty(this.filters.asset))
					return [];
				let asset = _.find(this.assets_columns, { 'name': this.filters.asset });
				if (asset) {
					let mapped = asset.columns.map(entry => ({ 'name': entry.name, 'value': entry.name }));
					mapped.unshift({ 'name': 'All columns', 'value': null });
					return mapped;
				}

				return [];
			}
		},

		watch: {
		},

		methods: {
			setActiveAsset(name) {
				this.filters.asset = name;
			},

			setActiveColumn(name) {
				this.filters.column = name;
			},

			fetchAssetsColumns() {
				if (this.assets_columns.length) return;
				this.isLoading = true;
				axios.get(process.env.VUE_APP_BASE_API_URL + '/parquet-service/assets/')
					.then((response) => {
						this.assets_columns = response.data;
						this.isLoading = false;
					})
					.catch(err => {
						console.log(err);
						this.isLoading = false;
					});
			},
			fetchData() {
				if (!this.filters.asset)
					return;
				let url = process.env.VUE_APP_BASE_API_URL + '/parquet-service/assets/' + this.filters.asset + '/';
				if (this.filters.column)
					url += 'columns/' + this.filters.column + '/';

				this.isLoading = true;
				axios.get(url,
					{
						params: {
							start_date: this.filters.start_date,
							end_date: this.filters.end_date
						}
					})
					.then((response) => {
						if (!_.isEmpty(response.data)) {
							this.parquet = response.data;
						}
						else {
							this.info = 'No information was found by this criteria. Please try again ;)';
							this.snackbar = true;
						}
						this.isLoading = false;
					}).catch((error) => {
						console.log(error.response.data);
						this.errorMessage = error.response.data;
						this.alert = true;
						this.isLoading = false;
					});
			},
			reset() {
				this.filters = {
					asset: null,
					column: null,
					start_date: null,
					end_date: null
				};
				this.parquet = [];
			}
		}
	};
</script>
